Index: README
===================================================================
--- README	(revision c0cf6c8635981f082c57b1e4537672f169b18daa)
+++ README	(revision 2ee1d113d416fe0ba8e9b8c8ec9522b246fd7afc)
@@ -3,12 +3,15 @@
 1. INTRODUCTION::
 
-     This collection of scripts, known as jhalfs-X, strives to create
+     This collection of scripts, known as jhalfs, strives to create
   accurate makefiles from the Linux From Scratch book series XML files.
-  This software is an evolution of the original "jhalfs-0.2" code.
+  This software is an evolution of the original "jhalfs-0.2" code developed
+  by Jeremy Huntwork.
 
      The usage of this script assumes you have read and are familiar with
-  the book(s) and, therefore, the configuration variables found in config
-  files will have meaning to you. There are a number of command line switches
-  which, if used, will override the config file settings.
+  the book(s) and, therefore, the configuration variables found in menuconfig
+  interface will have meaning to you.
+
+  The list of supported books can be found at
+  http://wiki.linuxfromscratch.org/alfs/wiki/SupportedBooks
 
   NOTES::
@@ -32,127 +35,103 @@
        (user error, package bug, {c,h,b}LFS command bug, or jhalfs code bug)
 
-     If you don't have the above skill, please don't use this tool.
+     If you do not have the above skills, please don't use this tool.
 
 
 3. INSTALLATION::
-     No installation is required. System-wide installation is not allowed
-  for now.
-
-4. CONFIGURATION FILES::
-     Each book in the LFS series has its own set of configurable parameters
-  as well as the common parameters file.
-  
-     ::NEWS:: There is new configuration method for jhalfs.
-     
+
+     No installation is required. System-wide installation is not allowed.
+
+4. CONFIGURATION::
+
+     ::NEWS::
+         There is a new configuration method for jhalfs.
+
      We have installed the familiar menu based configuration tool driven by
-     make. If you type the command 
-       make
-     you will be presented with a list of configurable parameters (starting
-     with the book you wish to use). All the parameters found in the individual
-     config files are available. Once you have finished setting the parameters
-     and exit the make file will launch the chosen book version of jhalfs.
-     JHALFS will import your created file and overider the values found in normal
-     "config" files.
-     ..note.. The generated file <configuration> is only used by jhalfs if you
-     run jhalfs via make otherwise it is ignored.
-     
-     If you want to try out the new configuration system without running jhalfs
-     issue the following.
-       make menuconfig
-     This will create a new file named configuration but will not launch jhalfs.
-   
+     GNU make. see the section RUNNING, for details
+
 5. RUNNING::
-     The script master.sh cannot be invoked directly but only via the
-  supplied symlinks. After editing the config file for the project you wish
-  to build, run the script.
-
-     IMPORTANT:
-       If you use the switch -M (automatically run the generated makefile) you
-       must be 'root' or you can run the scripts using 'sudo'
-        i.e.  sudo ./lfs -G -M
-
-       If you want to run make manually you can only do so if you are 'root' or
-       via 'sudo'
-        i.e  (from within the jhalfs directory) sudo make
-
-     The term <symlink> refers to the 1 of 3 package symlinks, lfs,hlfs,clfs.
-     Replace <symlink> with your choice of packages; i.e.: ./lfs
-
-     ./<symlink>		eg: ./lfs or ./hlfs
-     Create a makefile based on the settings found in the config files.
-     You must enter the build partition/jhalfs directory and manually run <make>
-
-     ./<symlink> -G		eg: ./lfs -G
-     Download the packages and patches necessary to build <symlink>
-
-     ./<symlink> -G -M		eg: ./lfs -G -M
-     Download the packages, create and automatically run the Makefile
-
-     ./<symlink> --help		eg: ./lfs --help
-     will give you a context sensitive list of command line switches.
-
-   >>>> an expanded example
-
-   export SRC_ARCHIVE=/mnt/SourceFiles
-
-   ./lfs -D /mnt/partition4 \
-         -K ~/jhalfs_configs/linux-2.6.16.19-LFS.config \
-	 -F ~/jhalfs-configs/fstab-sda3 \
-	 -G -T 0 -M
-
-   explanation:::
-
-   export SRC_ARCHIVE=/mnt/SourceFiles
-      # This points to a local archive of existing packages. If the version in
-        the archive is incorrect jhalfs will access the net and download the
-	necessary version and store it here for later use. DO NOT set this to
-	$BUILDDIR/sources. If you do not set this variable to a valid directory
-	ALL package tarballs will be downloaded from the 'net.
-
-   -D /mnt/partition4
-      # where everything takes place.  ..NOTE it must already exist and be mounted
-
-   -K ~/jhalfs_configs/linux-2.6.16.19-LFS.config
-      # If you want to automatically build a the kernel you MUST supply a valid
-        kernel configuration file. The file you supply will be copied and renamed.
-
-   -F ~/jhalfs-configs/fstab-sda3
-      # If you have a fstab file you wish to use it will be copied and renamed
-
-   -G   # Retrieve the package files. You MUST enable this flag at least once if you
-          wish to do a build or whenever you update the book.
-
-   -T 0 # don't run any testsuites
-
-   -M   # automatically run make against Makefile once jhalfs finishes its work.
-
-
-6. LAYOUT::
-
-        /CLFS/config
-             /master.sh
-             /xxxx.xsl
-
-        /CLFS2/config
-              /master.sh
-              /xxxx.xsl
-
-        /HLFS/config
-             /master.sh
-             /xxxx.xsl
-
-        /LFS/config
-            / master.sh
-            /xxxx.xsl
-
-        /common/config
-               /common_functions
+
+     ::NEWS::
+         jhalfs is now launched via GNU make instead of individual symlinks.
+
+     The command <make> will launch a menu based configuration program. You will
+     recognize the layout from building the kernel or uClibc/BusyBox. The
+     underlying menu code was borrowed from BusyBox and slightly modified for
+     our use.
+
+     Help on parameter function is available from the online help. Please
+     make use of that feature for additional information not in this file.
+
+     Once you have set the parameters you wish and have saved your work the
+     jhalfs script is launch. The script verify first that the host can run
+     it and build the xLFS system, then validate the configuration and present
+     you with your selections which you may accept or reject.
+
+     If you accepted the displayed settings jhalfs will proceed to create the
+     Makefile, optionally download packages.
+
+     ::NEWS::
+         You must be logged as a normal user with sudo privileges to run
+         the Makefile.
+
+     NOTE::
+         If you run the jhalfs script directly the only function you can select
+         is to display the version number running <./jhalfs -v>
+
+6. BLFS_TOOL SUPPORT::
+
+     For books that support it, there is an option to install blfs-tool and its
+     dependendencies on the final system.
+
+     After booting the new xLFS system some steps are needed to finish
+     blfs-tool installation:
+
+       - A user account must be created. You must be logged on that user
+         account to use blfs-tool.
+
+       - Move /blfs-root to that user's home and change ownership of the
+         directory and files to the user.
+
+       - Give the user read and write privileges over the $TRACKING_DIR
+         directory and the files that it contains.
+
+       - Configure sudo, adding the needed privileges for the user.
+
+     We assume that blfs-tool will be used on a running fresh xLFS system.
+     To use it to build BLFS packages from the chroot jail is also possible,
+     but is for you to figure out how to do that.
+
+     To know how to blfs-tool works, see README.BLFS.
+
+7. LAYOUT::
+
+        /BLFS (see README.BLFS)
+
+        /CLFS/master.sh
+             /clfs.xsl
+
+        /CLFS2/master.sh
+              /clfs2.xsl
+
+        /HLFS/master.sh
+             /hlfs.xsl
+
+        /LFS/master.sh
+            /lfs.xsl
+
+        /common/common_functions
                /makefile_functions
                /func_check_versions.sh
                /func_validate_configs.sh
+               /packages.xsl
+               /urls.xsl
+               /create-sbu_du-report.sh
+               /func_compare.sh
+               /progress_bar.sh
+               /blfs-tool-deps/9xx-*
 
         /contrib/jhalfs-paco.patch
 
-	/extras/do_copy_files
+        /extras/do_copy_files
                /do_ica_prep
                /do_ica_work
@@ -160,15 +139,28 @@
                /filelist
 
-         README
-	 README.PACO
-	 TODO
-
-	 ./clfs  ---|
-	 ./clfs2 ---|
-	 ./hlfs  ---|+---> master.sh
-	 ./lfs   ---|
-
-
-7. FAQ::
+        /optimize/opt_config
+                 /opt_override
+                 /optimize_functions
+                 /opt_config.d/noOpt
+                              /noSymbols
+                              /O3pipe
+                              /O3pipe_march
+                              /defOpt_fPIC
+
+        /menu/*
+
+        README
+        README.BLFS
+        README.HLFS
+        README.PACO
+        TODO
+        LICENSE
+
+        Config.in
+        Makefile
+        jhalfs
+        blfs-tool
+
+8. FAQ::
     Q. "This 'help' file is very sparse"
     A. Yes, it is. This tool, jhalfs, is for those who understand the LFS books
@@ -177,9 +169,9 @@
 
     Q. "It doesn't work!"
-    A. Yes it does, try ./lfs --help
-       Remember you must either be 'root' to run this script or have 'sudo' privileges.
+    A. Yes it does, try >> make
+       Remember you must have 'sudo' privileges.
 
     Q. "It still doesn't work"
-    A. jhalfs was designed to work against the developement versions of the LFS
+    A. jhalfs was designed to work against the development versions of the LFS
        series of books. Consequently changes in a book(s) sometimes breaks older
        versions of jhalfs. Before you start pulling out your hair download the
@@ -194,17 +186,19 @@
        The layout below $BUILDDIR is as follows.
        $BUILDDIR/
-            jhalfs      (makefile,cmd scripts,logs..etc)
-	    sources     (where packages reside)
-	    tools       (temporary bootstrap system)
-	    cross-tools (temporary CLFS only)
-	        ...
-	    FHS dir structure
-	        ...
+            jhalfs      (Makefile, cmd scripts, logs, etc..)
+            sources     (where packages reside)
+            tools       (temporary bootstrap system)
+            cross-tools (temporary CLFS only)
+                ...
+            FHS dir structure
+                ...
+            blfs_root   (files to use blfs-tool if selected to install it)
 
     Q. "What is the function of the SRC_ARCHIVE variable?"
-    A. When then symlinked master.sh runs it creates a local copy of the
-       necessary packages in BUILDDIR/sources by downloading the files. If
-       the variable SRC_ARCHIVE is defined the software will first look in
-       this location for the file and, if found, will copy it to BUILDDIR/sources.
+    A. When jhalfs runs and packages download was selected, it creates a local
+       copy of the necessary packages in BUILDDIR/sources by downloading the
+       files. If the variable SRC_ARCHIVE is defined the software will first
+       look in this location for the file and, if found, will copy it to
+       BUILDDIR/sources.
        If the files are not found in SRC_ARCHIVE _and_ you have write priv to
        the directory any downloaded files will be mirrored there.
@@ -212,22 +206,28 @@
     Q. "How do I set the SRC_ARCHIVE location?"
     A. The best way to set the value of SRC_ARCHIVE is
+
        export SRC_ARCHIVE=/wherever/you/store/downloaded/packages
-                       OR
-       you can change the setting in common/config.
+
+       or you can set the full path in the proper menu entry.
 
     Q. "Why have 2 copies of the files?"
     A. The package files must be visible during the chroot phase and this is a
        simple and reliable method of doing so. This method also handles the CLFS
-       build method where the final build may be done on a separate machine.
-
-    Q. "What is the function of LUSER and LGROUP? There is no cmd line switch"
-    A. If you are running jhalfs from a low or non-priveledged account you may not
-       have the priv to create/delete accounts. These variables are adjustable
-       when invoking make. 
-         make LUSER=myaccount LGROUP=mygroup
-       Then only changes to your account will be the creation of a NEW .bashrc after
-       saving your original to .bashrc.XXX
-    
-    Q. "When I try to build 'xxx' with clfs the makefile fails at the mid-point"
+       boot build method where the final build may be done on a separate machine.
+
+    Q. "What is the function of "User account" and "Group account" menu settings?"
+    A. If you are running jhalfs from a low or non-privileged account you may not
+       have the priv to create/delete the user needed to build temporally tools.
+       These settings allow you to use your own user and group name to do that
+       build steps.
+
+       These variables are adjustable also when invoking make:
+
+         $BUILDDIR make LUSER=myaccount LGROUP=mygroup
+
+       The only changes to your account will be the creation of a NEW .bashrc
+       after saving your original to .bashrc.XXX
+
+    Q. "When I try to build CLFS the Makefile fails at the mid-point"
     A. There could be numerous reasons for the failure but the most likely reason
        is you are doing a cross-build using the 'chroot' method and the target is
@@ -238,7 +238,7 @@
        'boot' method to create your target code.
        As an extreme example: You can build a sparc target on a x86 platform but
-       only the temptools phase. You must run ./clfs using the 'boot' method and
-       not the 'chroot.' You must transfer the toolchain to a sparc platform, reboot
-       the sparc box and continue the build.
+       only the temptools phase. You must select the 'boot' method and not the
+       'chroot.' You must transfer the toolchain to a sparc platform, reboot the
+       sparc box and continue the build.
        Of all the LFS series of books Cross-LFS requires the greatest
        understanding of host/target hardware combination. Please read the book
@@ -248,3 +248,2 @@
   George Boudreau
   Manuel Canales Esparcia
-  Jeremy Huntwork
